SystemOrganization addCategory: #'NagareTest-Core'!

TestCase subclass: #NgLogTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NagareTest-Core'!

!NgLogTest commentStamp: 'mu 5/3/2012 16:27' prior: 0!
self suite run!

!NgLogTest methodsFor: 'private' stamp: 'mu 5/4/2012 17:43'!
asString: anObject
	"For VW"
	(anObject isKindOf: String) ifTrue: [^anObject asString].
	(anObject isKindOf: ByteArray) ifTrue: [^anObject asString].
	^ anObject printString! !

!NgLogTest methodsFor: 'private' stamp: 'mu 5/4/2012 17:43'!
asStringDictionary: bytesDict 
	| dict |
	dict := Dictionary new.
	bytesDict
		keysAndValuesDo: [:k :v | dict at: k asString put: (self asString: v)].
	^ dict! !

!NgLogTest methodsFor: 'private' stamp: 'mu 5/3/2012 16:41'!
logs
	| messages mpBytesCol |
	mpBytesCol := NgPortableUtil default bytesSent.
	messages := self ng settings useStomp
				ifTrue: [mpBytesCol
						collect: [:each | Object fromStomp: each]]
				ifFalse: [mpBytesCol
						collect: [:each | MpMessagePack unpack: each]].
	^ messages
		collect: [:each | 
			each at: 1 put: (each at: 1) asString.
			each]! !

!NgLogTest methodsFor: 'running' stamp: 'mu 5/3/2012 15:42'!
setUp
	NgMockPortableUtil beDefault! !

!NgLogTest methodsFor: 'running' stamp: 'mu 5/3/2012 15:43'!
tearDown
	NgMockPortableUtil releaseDefault! !

!NgLogTest methodsFor: 'testing' stamp: 'MasashiUmezawa 6/12/2016 14:36'!
testAccess
	| logs |
	"self debug: #testAccess"
	self ng access: 'test1'.
	self ng access: 222.
	logs := self logs.
	self assert: logs size = 2.
	self assert: ((logs at: 1) at: 1) = self ng accessTag.
	self assert: ((logs at: 2) at: 1) = self ng accessTag.
	
	self assert: ((logs at: 1) at: 3) asString = 'test1'.
	self assert: ((logs at: 2) at: 3) = 222! !

!NgLogTest methodsFor: 'testing' stamp: 'MasashiUmezawa 6/12/2016 14:37'!
testAdmin
	| logs |
	"self debug: #testAdmin"
	self ng admin: 'test1'.
	self ng admin: 222.
	logs := self logs.
	self assert: logs size = 2.
	self assert: ((logs at: 1) at: 1) = self ng adminTag.
	self assert: ((logs at: 2) at: 1) = self ng adminTag.
	
	self assert: ((logs at: 1) at: 3) asString = 'test1'.
	self assert: ((logs at: 2) at: 3) = 222! !

!NgLogTest methodsFor: 'testing' stamp: 'mu 5/3/2012 21:22'!
testComprexLog
	"self debug: #testComprexLog"
	"Log arbitrary complex records"
	"Requires StOMP"
	
	| logs origRecord retrievedRecord |
	self assert: (Object canUnderstand: #toStomp).
	self ng settings: (NgSettings new useStomp: true; yourself).
	
	self ng debug: 'test1'.
	self ng info: #test2 -> 222.
	origRecord := Array with: #test3->3.14 with: (#time -> Time now) with: (#date -> Date today).
	self ng fatal: origRecord.
	
	logs := self logs.
	
	self assert: logs size = 3.
	self assert: ((logs at: 1) at: 1) = self ng debugTag.
	self assert: ((logs at: 2) at: 1) = self ng infoTag.
	self assert: ((logs at: 3) at: 1) = self ng fatalTag.
	
	self assert: ((logs at: 1) at: 3) = 'test1'.
	self assert: ((logs at: 2) at: 3) = (#test2 -> 222).
	retrievedRecord := ((logs at: 3) at: 3).
	self assert: retrievedRecord size = origRecord size.
	self assert: (retrievedRecord at: 1) = (origRecord at: 1).
	self assert: (retrievedRecord at: 2) key = (origRecord at: 2) key.
	self assert: (retrievedRecord at: 2) value asSeconds = (origRecord at: 2) value asSeconds.
	self assert: (retrievedRecord at: 3) key = (origRecord at: 3) key.
	self assert: (retrievedRecord at: 3) value asSeconds = (origRecord at: 3) value asSeconds.
	
	self ng settings: nil! !

!NgLogTest methodsFor: 'testing' stamp: 'MasashiUmezawa 6/12/2016 14:37'!
testDebug
	| logs |
	"self debug: #testDebug"	
	self ng debug: 'test1'.
	self ng debug: 222.
	logs := self logs.
	self assert: logs size = 2.
	self assert: ((logs at: 1) at: 1) = self ng debugTag.
	self assert: ((logs at: 2) at: 1) = self ng debugTag.
	
	self assert: ((logs at: 1) at: 3) asString = 'test1'.
	self assert: ((logs at: 2) at: 3) = 222! !

!NgLogTest methodsFor: 'testing' stamp: 'mu 5/3/2012 16:26'!
testExceptionLog
	"self debug: #testExceptionLog"
	
	| errorInfo |
	[1/0] on: Error do: [:ex | ex ngLog].
	
	self assert: self logs size = 1.
	self assert: ((self logs at: 1) at: 1) = self ng errorTag.
	
	errorInfo := self asStringDictionary: ((self logs at: 1) at: 3).
	
	self assert:  (errorInfo at: 'receiver') = '1'.
	self assert:  (errorInfo includesKey: 'description').
	self assert:  (errorInfo includesKey: 'stack')! !

!NgLogTest methodsFor: 'testing' stamp: 'MasashiUmezawa 6/12/2016 14:36'!
testInfo
	| logs |
	"self debug: #testInfo"
	self ng info: 'test1'.
	self ng info: 222.
	logs := self logs.
	self assert: logs size = 2.
	self assert: ((logs at: 1) at: 1) = self ng infoTag.
	self assert: ((logs at: 2) at: 1) = self ng infoTag.
	
	self assert: ((logs at: 1) at: 3) asString = 'test1'.
	self assert: ((logs at: 2) at: 3) = 222! !

!NgLogTest methodsFor: 'testing' stamp: 'mu 5/3/2012 16:07'!
testLogLevelZero
	"self debug: #testLogLevelZero"
	self ng settings: (NgSettings new logLevel: 0; yourself).
	self ng debug: 'test1'.
	self ng debug: 222.
	
	self assert: self logs size = 0.
	
	self ng settings: nil! !

!NgLogTest methodsFor: 'testing' stamp: 'mu 5/3/2012 16:29'!
testPerfLog
	"self debug: #testPerfLog"
	| msecs errorInfo |
	msecs := [1000 factorial] ngLogTimeAt: '10000 factorial' description: 'testPerfLog'.
	
	self assert: self logs size = 1.
	self assert: ((self logs at: 1) at: 1) = self ng perfTag.
	errorInfo := self asStringDictionary: ((self logs at: 1) at: 3).
	
	self assert:  (errorInfo at: 'msecs') = msecs printString.
	self assert:  (errorInfo at: 'tracePoint') = '10000 factorial'.
	self assert:  (errorInfo at: 'description') = 'testPerfLog'.! !

!NgLogTest methodsFor: 'testing' stamp: 'MasashiUmezawa 6/12/2016 14:38'!
testPrefix
	| logs |
	"self debug: #testPrefix"
	self >@ 'myApp' access: 'test1'.
	self ng info: 222.
	self >@ 'myApp'  info: 333.
	
	logs := self logs.
	self assert: logs size = 3.
	self assert: ((logs at: 1) at: 1) = (self >@ 'myApp') accessTag.
	self assert: ((logs at: 2) at: 1) = (self ng) infoTag.
	self assert: ((logs at: 3) at: 1) = (self >@ 'myApp') infoTag.
	
	self assert: ((logs at: 1) at: 3) asString = 'test1'.
	self assert: ((logs at: 2) at: 3) = 222.
	self assert: ((logs at: 3) at: 3) = 333.
	
	(self >@ 'myApp') release! !

NgPortableUtil subclass: #NgMockPortableUtil
	instanceVariableNames: 'delegate bytesSent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NagareTest-Core'!

!NgMockPortableUtil class methodsFor: 'actions' stamp: 'mu 5/3/2012 15:39'!
beDefault
	NgPortableUtil default release.
	NgPortableUtil initDefault.
	self activate.! !

!NgMockPortableUtil class methodsFor: 'actions' stamp: 'mu 5/3/2012 15:39'!
releaseDefault
	NgPortableUtil default release.
	NgPortableUtil initDefault.
	NgPortableUtil defaultActualClass activate! !

!NgMockPortableUtil methodsFor: 'accessing' stamp: 'mu 5/3/2012 15:24'!
bytesSent
	^bytesSent ifNil: [bytesSent := OrderedCollection new]! !

!NgMockPortableUtil methodsFor: 'accessing' stamp: 'mu 5/3/2012 15:37'!
delegate
	^delegate ifNil: [delegate := NgPortableUtil defaultActualClass new]! !

!NgMockPortableUtil methodsFor: 'initialize-release' stamp: 'mu 5/3/2012 15:24'!
initialize
	super initialize.
	delegate := nil.
	bytesSent := nil! !

!NgMockPortableUtil methodsFor: 'initialize-release' stamp: 'mu 5/3/2012 15:24'!
release
	super release
	delegate ifNotNil: [delegate release].
	delegate := nil.
	bytesSent := nil! !

!NgMockPortableUtil methodsFor: 'sending' stamp: 'mu 5/3/2012 15:41'!
sendBytes: bytes
	self bytesSent add: bytes! !

!NgMockPortableUtil methodsFor: 'converting' stamp: 'mu 5/3/2012 15:22'!
shortStackStringFrom: anException
	^self delegate shortStackStringFrom: anException! !

!NgMockPortableUtil methodsFor: 'accessing' stamp: 'mu 5/3/2012 15:19'!
unixTimeSeconds
	^ self delegate unixTimeSeconds! !
